
#ifndef _NEWTON_H
#define _NEWTON_H

#include <stdbool.h>
#include <complex.h>

#include "formparse.h"
#include "eval.h"

#ifndef NEXTERN
extern bool interrupted;
extern mfuncs_t mfunctions[];
extern mvars_t mvariables[];
#endif

#define MIN_ITR 1
#define MAX_ITR ((1 << (sizeof(unsigned short)*8))-1)

typedef double (*inrange)(unsigned int);

// todo: remove x, y, make itr and int and fz a double containing just the cabs(fz)-value

struct root_s;

typedef struct list_s {
	double complex z;
	double complex fz;		// |fz| -> 1/value?
	struct root_s *root;
	// unsigned short x, y;
	unsigned short itr;		// -> 1/saturation or 1/value and saturation = 1
} list_t;

typedef struct root_s {
	struct root_s *next;
	double complex z;		// -> hue
	double accuracy;
	div_t dhi;
} root_t;

typedef struct {
	unsigned int width, height;				// width and height of the image to render
	list_t *litarr;
	root_t *roots;
	unsigned int nroots;
	unsigned int step;
	unsigned int off;
	unsigned int itr;						// maximal number of iterations to perform
	double eps;								// error allowed between two roots
	double complex rng_lower, rng_upper;	// edges of rectangle to render in complex plane
	bool verbose;
	bool fullscreen;
	bool interrupted;
	form_t f;								// f(z)
	form_t df;								// f'(z)
	inrange maprngx, maprngy;				// map pixels to coordinates in the complex space
} render_t;

#endif
